#ifndef LIB_ERRDEFINITIONS_MQH_INCLUDED
#define LIB_ERRDEFINITIONS_MQH_INCLUDED
/**********************************************************************************
 * Copyright (C) 2010-2022 Dominik Egert <info@freie-netze.de>
 *
 * This file is error code error MQL definitions include file.
 *
 * MQLplus, including this file may not be copied and/or distributed 
 * without explecit permit by the author.
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 4.2
 *  State: public
 *
 *  File information
 *  ================
 *
 *
 *  Use: resolve error codes to text.
 *
 *      Content is provided as is. All text
 *      and definitions have been extracted from
 *      https://www.mql5.com/en/docs/constants/errorswarnings/errorcodes
 *		https://www.mql5.com/en/docs/constants/errorswarnings/enum_trade_return_codes
 *
 *      Feel free to edit or add any new codes
 *
 * 	Date of update: 15. April 2022
*/
#ifdef DBG_MSG_TRACE_FILE_LOADER
    DBG_MSG_TRACE_FILE_LOADER;

#endif



/////////////////////////////////////////////////////////////////////
//
//  MQL API defined error codes
//  and descriptions.
//
//  Sadly some of the official defined error
//  codes are missing somehow. Therefore we
//  define them here.
//


/////////////////////////////////////////////////////////////////////
//
// General
//
#ifndef ERR_SUCCESS
    #define ERR_SUCCESS                                  0
#endif
#ifndef ERR_INTERNAL_ERROR
    #define ERR_INTERNAL_ERROR                           4001
#endif
#ifndef ERR_WRONG_INTERNAL_PARAMETER
    #define ERR_WRONG_INTERNAL_PARAMETER                 4002
#endif
#ifndef ERR_INVALID_PARAMETER
    #define ERR_INVALID_PARAMETER                        4003
#endif
#ifndef ERR_NOT_ENOUGH_MEMORY
    #define ERR_NOT_ENOUGH_MEMORY                        4004
#endif
#ifndef ERR_STRUCT_WITHOBJECTS_ORCLASS
    #define ERR_STRUCT_WITHOBJECTS_ORCLASS               4005
#endif
#ifndef ERR_INVALID_ARRAY
    #define ERR_INVALID_ARRAY                            4006
#endif
#ifndef ERR_ARRAY_RESIZE_ERROR
    #define ERR_ARRAY_RESIZE_ERROR                       4007
#endif
#ifndef ERR_STRING_RESIZE_ERROR
    #define ERR_STRING_RESIZE_ERROR                      4008
#endif
#ifndef ERR_NOTINITIALIZED_STRING
    #define ERR_NOTINITIALIZED_STRING                    4009
#endif
#ifndef ERR_INVALID_DATETIME
    #define ERR_INVALID_DATETIME                         4010
#endif
#ifndef ERR_ARRAY_BAD_SIZE
    #define ERR_ARRAY_BAD_SIZE                           4011
#endif
#ifndef ERR_INVALID_POINTER
    #define ERR_INVALID_POINTER                          4012
#endif
#ifndef ERR_INVALID_POINTER_TYPE
    #define ERR_INVALID_POINTER_TYPE                     4013
#endif
#ifndef ERR_FUNCTION_NOT_ALLOWED
    #define ERR_FUNCTION_NOT_ALLOWED                     4014
#endif
#ifndef ERR_RESOURCE_NAME_DUPLICATED
    #define ERR_RESOURCE_NAME_DUPLICATED                 4015
#endif
#ifndef ERR_RESOURCE_NOT_FOUND
    #define ERR_RESOURCE_NOT_FOUND                       4016
#endif
#ifndef ERR_RESOURCE_UNSUPPOTED_TYPE
    #define ERR_RESOURCE_UNSUPPOTED_TYPE                 4017
#endif
#ifndef ERR_RESOURCE_UNSUPPORTED_TYPE
    #define ERR_RESOURCE_UNSUPPORTED_TYPE                4017
#endif
#ifndef ERR_RESOURCE_NAME_IS_TOO_LONG
    #define ERR_RESOURCE_NAME_IS_TOO_LONG                4018
#endif
#ifndef ERR_MATH_OVERFLOW
    #define ERR_MATH_OVERFLOW                            4019
#endif
#ifndef ERR_SLEEP_ERROR
    #define ERR_SLEEP_ERROR                              4020
#endif
#ifndef ERR_PROGRAM_STOPPED
    #define ERR_PROGRAM_STOPPED                          4022
#endif


/////////////////////////////////////////////////////////////////////
//
// Charts
//
#ifndef ERR_CHART_WRONG_ID
    #define ERR_CHART_WRONG_ID                           4101
#endif
#ifndef ERR_CHART_NO_REPLY
    #define ERR_CHART_NO_REPLY                           4102
#endif
#ifndef ERR_CHART_NOT_FOUND
    #define ERR_CHART_NOT_FOUND                          4103
#endif
#ifndef ERR_CHART_NO_EXPERT
    #define ERR_CHART_NO_EXPERT                          4104
#endif
#ifndef ERR_CHART_CANNOT_OPEN
    #define ERR_CHART_CANNOT_OPEN                        4105
#endif
#ifndef ERR_CHART_CANNOT_CHANGE
    #define ERR_CHART_CANNOT_CHANGE                      4106
#endif
#ifndef ERR_CHART_WRONG_PARAMETER
    #define ERR_CHART_WRONG_PARAMETER                    4107
#endif
#ifndef ERR_CHART_CANNOT_CREATE_TIMER
    #define ERR_CHART_CANNOT_CREATE_TIMER                4108
#endif
#ifndef ERR_CHART_WRONG_PROPERTY
    #define ERR_CHART_WRONG_PROPERTY                     4109
#endif
#ifndef ERR_CHART_SCREENSHOT_FAILED
    #define ERR_CHART_SCREENSHOT_FAILED                  4110
#endif
#ifndef ERR_CHART_NAVIGATE_FAILED
    #define ERR_CHART_NAVIGATE_FAILED                    4111
#endif
#ifndef ERR_CHART_TEMPLATE_FAILED
    #define ERR_CHART_TEMPLATE_FAILED                    4112
#endif
#ifndef ERR_CHART_WINDOW_NOT_FOUND
    #define ERR_CHART_WINDOW_NOT_FOUND                   4113
#endif
#ifndef ERR_CHART_INDICATOR_CANNOT_ADD
    #define ERR_CHART_INDICATOR_CANNOT_ADD               4114
#endif
#ifndef ERR_CHART_INDICATOR_CANNOT_DEL
    #define ERR_CHART_INDICATOR_CANNOT_DEL               4115
#endif
#ifndef ERR_CHART_INDICATOR_NOT_FOUND
    #define ERR_CHART_INDICATOR_NOT_FOUND                4116
#endif


/////////////////////////////////////////////////////////////////////
//
// Graphical Objects
//
#ifndef ERR_OBJECT_ERROR
    #define ERR_OBJECT_ERROR                             4201
#endif
#ifndef ERR_OBJECT_NOT_FOUND
    #define ERR_OBJECT_NOT_FOUND                         4202
#endif
#ifndef ERR_OBJECT_WRONG_PROPERTY
    #define ERR_OBJECT_WRONG_PROPERTY                    4203
#endif
#ifndef ERR_OBJECT_GETDATE_FAILED
    #define ERR_OBJECT_GETDATE_FAILED                    4204
#endif
#ifndef ERR_OBJECT_GETVALUE_FAILED
    #define ERR_OBJECT_GETVALUE_FAILED                   4205
#endif


/////////////////////////////////////////////////////////////////////
//
// MarketInfo
//
#ifndef ERR_MARKET_UNKNOWN_SYMBOL
    #define ERR_MARKET_UNKNOWN_SYMBOL                    4301
#endif
#ifndef ERR_MARKET_NOT_SELECTED
    #define ERR_MARKET_NOT_SELECTED                      4302
#endif
#ifndef ERR_MARKET_WRONG_PROPERTY
    #define ERR_MARKET_WRONG_PROPERTY                    4303
#endif
#ifndef ERR_MARKET_LASTTIME_UNKNOWN
    #define ERR_MARKET_LASTTIME_UNKNOWN                  4304
#endif
#ifndef ERR_MARKET_SELECT_ERROR
    #define ERR_MARKET_SELECT_ERROR                      4305
#endif


/////////////////////////////////////////////////////////////////////
//
// History Access
//
#ifndef ERR_HISTORY_NOT_FOUND
    #define ERR_HISTORY_NOT_FOUND                        4401
#endif
#ifndef ERR_HISTORY_WRONG_PROPERTY
    #define ERR_HISTORY_WRONG_PROPERTY                   4402
#endif
#ifndef ERR_HISTORY_TIMEOUT
    #define ERR_HISTORY_TIMEOUT                          4403
#endif
#ifndef ERR_HISTORY_BARS_LIMIT
    #define ERR_HISTORY_BARS_LIMIT                       4404
#endif
#ifndef ERR_HISTORY_LOAD_ERRORS
    #define ERR_HISTORY_LOAD_ERRORS                      4405
#endif
#ifndef ERR_HISTORY_SMALL_BUFFER
    #define ERR_HISTORY_SMALL_BUFFER                     4407
#endif


/////////////////////////////////////////////////////////////////////
//
// Global_Variables
//
#ifndef ERR_GLOBALVARIABLE_NOT_FOUND
    #define ERR_GLOBALVARIABLE_NOT_FOUND                 4501
#endif
#ifndef ERR_GLOBALVARIABLE_EXISTS
    #define ERR_GLOBALVARIABLE_EXISTS                    4502
#endif
#ifndef ERR_GLOBALVARIABLE_NOT_MODIFIED
    #define ERR_GLOBALVARIABLE_NOT_MODIFIED              4503
#endif
#ifndef ERR_GLOBALVARIABLE_CANNOTREAD
    #define ERR_GLOBALVARIABLE_CANNOTREAD                4504
#endif
#ifndef ERR_GLOBALVARIABLE_CANNOTWRITE
    #define ERR_GLOBALVARIABLE_CANNOTWRITE               4505
#endif
#ifndef ERR_MAIL_SEND_FAILED
    #define ERR_MAIL_SEND_FAILED                         4510
#endif
#ifndef ERR_PLAY_SOUND_FAILED
    #define ERR_PLAY_SOUND_FAILED                        4511
#endif
#ifndef ERR_MQL5_WRONG_PROPERTY
    #define ERR_MQL5_WRONG_PROPERTY                      4512
#endif
#ifndef ERR_TERMINAL_WRONG_PROPERTY
    #define ERR_TERMINAL_WRONG_PROPERTY                  4513
#endif
#ifndef ERR_FTP_SEND_FAILED
    #define ERR_FTP_SEND_FAILED                          4514
#endif
#ifndef ERR_NOTIFICATION_SEND_FAILED
    #define ERR_NOTIFICATION_SEND_FAILED                 4515
#endif
#ifndef ERR_NOTIFICATION_WRONG_PARAMETER
    #define ERR_NOTIFICATION_WRONG_PARAMETER             4516
#endif
#ifndef ERR_NOTIFICATION_WRONG_SETTINGS
    #define ERR_NOTIFICATION_WRONG_SETTINGS              4517
#endif
#ifndef ERR_NOTIFICATION_TOO_FREQUENT
    #define ERR_NOTIFICATION_TOO_FREQUENT                4518
#endif
#ifndef ERR_FTP_NOSERVER
    #define ERR_FTP_NOSERVER                             4519
#endif
#ifndef ERR_FTP_NOLOGIN
    #define ERR_FTP_NOLOGIN                              4520
#endif
#ifndef ERR_FTP_FILE_ERROR
    #define ERR_FTP_FILE_ERROR                           4521
#endif
#ifndef ERR_FTP_CONNECT_FAILED
    #define ERR_FTP_CONNECT_FAILED                       4522
#endif
#ifndef ERR_FTP_CHANGEDIR
    #define ERR_FTP_CHANGEDIR                            4523
#endif
//#ifndef ERR_FTP_CLOSED
//    #define ERR_FTP_CLOSED                               4524
//#endif


/////////////////////////////////////////////////////////////////////
//
// Custom Indicator Buffers
//
#ifndef ERR_BUFFERS_NO_MEMORY
    #define ERR_BUFFERS_NO_MEMORY                        4601
#endif
#ifndef ERR_BUFFERS_WRONG_INDEX
    #define ERR_BUFFERS_WRONG_INDEX                      4602
#endif


/////////////////////////////////////////////////////////////////////
//
// Custom Indicator Properties
//
#ifndef ERR_CUSTOM_WRONG_PROPERTY
    #define ERR_CUSTOM_WRONG_PROPERTY                    4603
#endif


/////////////////////////////////////////////////////////////////////
//
// Account
//
#ifndef ERR_ACCOUNT_WRONG_PROPERTY
    #define ERR_ACCOUNT_WRONG_PROPERTY                   4701
#endif
#ifndef ERR_TRADE_WRONG_PROPERTY
    #define ERR_TRADE_WRONG_PROPERTY                     4751
#endif
#ifndef ERR_TRADE_DISABLED
    #define ERR_TRADE_DISABLED                           4752
#endif
#ifndef ERR_TRADE_POSITION_NOT_FOUND
    #define ERR_TRADE_POSITION_NOT_FOUND                 4753
#endif
#ifndef ERR_TRADE_ORDER_NOT_FOUND
    #define ERR_TRADE_ORDER_NOT_FOUND                    4754
#endif
#ifndef ERR_TRADE_DEAL_NOT_FOUND
    #define ERR_TRADE_DEAL_NOT_FOUND                     4755
#endif
#ifndef ERR_TRADE_SEND_FAILED
    #define ERR_TRADE_SEND_FAILED                        4756
#endif
#ifndef ERR_TRADE_CALC_FAILED
    #define ERR_TRADE_CALC_FAILED                        4758
#endif


/////////////////////////////////////////////////////////////////////
//
// Indicators
//
#ifndef ERR_INDICATOR_UNKNOWN_SYMBOL
    #define ERR_INDICATOR_UNKNOWN_SYMBOL                 4801
#endif
#ifndef ERR_INDICATOR_CANNOT_CREATE
    #define ERR_INDICATOR_CANNOT_CREATE                  4802
#endif
#ifndef ERR_INDICATOR_NO_MEMORY
    #define ERR_INDICATOR_NO_MEMORY                      4803
#endif
#ifndef ERR_INDICATOR_CANNOT_APPLY
    #define ERR_INDICATOR_CANNOT_APPLY                   4804
#endif
#ifndef ERR_INDICATOR_CANNOT_ADD
    #define ERR_INDICATOR_CANNOT_ADD                     4805
#endif
#ifndef ERR_INDICATOR_DATA_NOT_FOUND
    #define ERR_INDICATOR_DATA_NOT_FOUND                 4806
#endif
#ifndef ERR_INDICATOR_WRONG_HANDLE
    #define ERR_INDICATOR_WRONG_HANDLE                   4807
#endif
#ifndef ERR_INDICATOR_WRONG_PARAMETERS
    #define ERR_INDICATOR_WRONG_PARAMETERS               4808
#endif
#ifndef ERR_INDICATOR_PARAMETERS_MISSING
    #define ERR_INDICATOR_PARAMETERS_MISSING             4809
#endif
#ifndef ERR_INDICATOR_CUSTOM_NAME
    #define ERR_INDICATOR_CUSTOM_NAME                    4810
#endif
#ifndef ERR_INDICATOR_PARAMETER_TYPE
    #define ERR_INDICATOR_PARAMETER_TYPE                 4811
#endif
#ifndef ERR_INDICATOR_WRONG_INDEX
    #define ERR_INDICATOR_WRONG_INDEX                    4812
#endif


/////////////////////////////////////////////////////////////////////
//
// Depth of Market
//
#ifndef ERR_BOOKS_CANNOT_ADD
    #define ERR_BOOKS_CANNOT_ADD                         4901
#endif
#ifndef ERR_BOOKS_CANNOT_DELETE
    #define ERR_BOOKS_CANNOT_DELETE                      4902
#endif
#ifndef ERR_BOOKS_CANNOT_GET
    #define ERR_BOOKS_CANNOT_GET                         4903
#endif
#ifndef ERR_BOOKS_CANNOT_SUBSCRIBE
    #define ERR_BOOKS_CANNOT_SUBSCRIBE                   4904
#endif


/////////////////////////////////////////////////////////////////////
//
// File Operations
//
#ifndef ERR_TOO_MANY_FILES
    #define ERR_TOO_MANY_FILES                           5001
#endif
#ifndef ERR_WRONG_FILENAME
    #define ERR_WRONG_FILENAME                           5002
#endif
#ifndef ERR_TOO_LONG_FILENAME
    #define ERR_TOO_LONG_FILENAME                        5003
#endif
#ifndef ERR_CANNOT_OPEN_FILE
    #define ERR_CANNOT_OPEN_FILE                         5004
#endif
#ifndef ERR_FILE_CACHEBUFFER_ERROR
    #define ERR_FILE_CACHEBUFFER_ERROR                   5005
#endif
#ifndef ERR_CANNOT_DELETE_FILE
    #define ERR_CANNOT_DELETE_FILE                       5006
#endif
#ifndef ERR_INVALID_FILEHANDLE
    #define ERR_INVALID_FILEHANDLE                       5007
#endif
#ifndef ERR_WRONG_FILEHANDLE
    #define ERR_WRONG_FILEHANDLE                         5008
#endif
#ifndef ERR_FILE_NOTTOWRITE
    #define ERR_FILE_NOTTOWRITE                          5009
#endif
#ifndef ERR_FILE_NOTTOREAD
    #define ERR_FILE_NOTTOREAD                           5010
#endif
#ifndef ERR_FILE_NOTBIN
    #define ERR_FILE_NOTBIN                              5011
#endif
#ifndef ERR_FILE_NOTTXT
    #define ERR_FILE_NOTTXT                              5012
#endif
#ifndef ERR_FILE_NOTTXTORCSV
    #define ERR_FILE_NOTTXTORCSV                         5013
#endif
#ifndef ERR_FILE_NOTCSV
    #define ERR_FILE_NOTCSV                              5014
#endif
#ifndef ERR_FILE_READERROR
    #define ERR_FILE_READERROR                           5015
#endif
#ifndef ERR_FILE_BINSTRINGSIZE
    #define ERR_FILE_BINSTRINGSIZE                       5016
#endif
#ifndef ERR_INCOMPATIBLE_FILE
    #define ERR_INCOMPATIBLE_FILE                        5017
#endif
#ifndef ERR_FILE_IS_DIRECTORY
    #define ERR_FILE_IS_DIRECTORY                        5018
#endif
#ifndef ERR_FILE_NOT_EXIST
    #define ERR_FILE_NOT_EXIST                           5019
#endif
#ifndef ERR_FILE_CANNOT_REWRITE
    #define ERR_FILE_CANNOT_REWRITE                      5020
#endif
#ifndef ERR_WRONG_DIRECTORYNAME
    #define ERR_WRONG_DIRECTORYNAME                      5021
#endif
#ifndef ERR_DIRECTORY_NOT_EXIST
    #define ERR_DIRECTORY_NOT_EXIST                      5022
#endif
#ifndef ERR_FILE_ISNOT_DIRECTORY
    #define ERR_FILE_ISNOT_DIRECTORY                     5023
#endif
#ifndef ERR_CANNOT_DELETE_DIRECTORY
    #define ERR_CANNOT_DELETE_DIRECTORY                  5024
#endif
#ifndef ERR_CANNOT_CLEAN_DIRECTORY
    #define ERR_CANNOT_CLEAN_DIRECTORY                   5025
#endif
#ifndef ERR_FILE_WRITEERROR
    #define ERR_FILE_WRITEERROR                          5026
#endif
#ifndef ERR_FILE_ENDOFFILE
    #define ERR_FILE_ENDOFFILE                           5027
#endif


/////////////////////////////////////////////////////////////////////
//
// String Casting
//
#ifndef ERR_NO_STRING_DATE
    #define ERR_NO_STRING_DATE                           5030
#endif
#ifndef ERR_WRONG_STRING_DATE
    #define ERR_WRONG_STRING_DATE                        5031
#endif
#ifndef ERR_WRONG_STRING_TIME
    #define ERR_WRONG_STRING_TIME                        5032
#endif
#ifndef ERR_STRING_TIME_ERROR
    #define ERR_STRING_TIME_ERROR                        5033
#endif
#ifndef ERR_STRING_OUT_OF_MEMORY
    #define ERR_STRING_OUT_OF_MEMORY                     5034
#endif
#ifndef ERR_STRING_SMALL_LEN
    #define ERR_STRING_SMALL_LEN                         5035
#endif
#ifndef ERR_STRING_TOO_BIGNUMBER
    #define ERR_STRING_TOO_BIGNUMBER                     5036
#endif
#ifndef ERR_WRONG_FORMATSTRING
    #define ERR_WRONG_FORMATSTRING                       5037
#endif
#ifndef ERR_TOO_MANY_FORMATTERS
    #define ERR_TOO_MANY_FORMATTERS                      5038
#endif
#ifndef ERR_TOO_MANY_PARAMETERS
    #define ERR_TOO_MANY_PARAMETERS                      5039
#endif
#ifndef ERR_WRONG_STRING_PARAMETER
    #define ERR_WRONG_STRING_PARAMETER                   5040
#endif
#ifndef ERR_STRINGPOS_OUTOFRANGE
    #define ERR_STRINGPOS_OUTOFRANGE                     5041
#endif
#ifndef ERR_STRING_ZEROADDED
    #define ERR_STRING_ZEROADDED                         5042
#endif
#ifndef ERR_STRING_UNKNOWNTYPE
    #define ERR_STRING_UNKNOWNTYPE                       5043
#endif
#ifndef ERR_WRONG_STRING_OBJECT
    #define ERR_WRONG_STRING_OBJECT                      5044
#endif


/////////////////////////////////////////////////////////////////////
//
// Operations with Arrays
//
#ifndef ERR_INCOMPATIBLE_ARRAYS
    #define ERR_INCOMPATIBLE_ARRAYS                      5050
#endif
#ifndef ERR_SMALL_ASSERIES_ARRAY
    #define ERR_SMALL_ASSERIES_ARRAY                     5051
#endif
#ifndef ERR_SMALL_ARRAY
    #define ERR_SMALL_ARRAY                              5052
#endif
#ifndef ERR_ZEROSIZE_ARRAY
    #define ERR_ZEROSIZE_ARRAY                           5053
#endif
#ifndef ERR_NUMBER_ARRAYS_ONLY
    #define ERR_NUMBER_ARRAYS_ONLY                       5054
#endif
#ifndef ERR_ONEDIM_ARRAYS_ONLY
    #define ERR_ONEDIM_ARRAYS_ONLY                       5055
#endif
#ifndef ERR_SERIES_ARRAY
    #define ERR_SERIES_ARRAY                             5056
#endif
#ifndef ERR_DOUBLE_ARRAY_ONLY
    #define ERR_DOUBLE_ARRAY_ONLY                        5057
#endif
#ifndef ERR_FLOAT_ARRAY_ONLY
    #define ERR_FLOAT_ARRAY_ONLY                         5058
#endif
#ifndef ERR_LONG_ARRAY_ONLY
    #define ERR_LONG_ARRAY_ONLY                          5059
#endif
#ifndef ERR_INT_ARRAY_ONLY
    #define ERR_INT_ARRAY_ONLY                           5060
#endif
#ifndef ERR_SHORT_ARRAY_ONLY
    #define ERR_SHORT_ARRAY_ONLY                         5061
#endif
#ifndef ERR_CHAR_ARRAY_ONLY
    #define ERR_CHAR_ARRAY_ONLY                          5062
#endif
#ifndef ERR_STRING_ARRAY_ONLY
    #define ERR_STRING_ARRAY_ONLY                        5063
#endif


/////////////////////////////////////////////////////////////////////
//
// Operations with OpenCL
//
#ifndef ERR_OPENCL_NOT_SUPPORTED
    #define ERR_OPENCL_NOT_SUPPORTED                     5100
#endif
#ifndef ERR_OPENCL_INTERNAL
    #define ERR_OPENCL_INTERNAL                          5101
#endif
#ifndef ERR_OPENCL_INVALID_HANDLE
    #define ERR_OPENCL_INVALID_HANDLE                    5102
#endif
#ifndef ERR_OPENCL_CONTEXT_CREATE
    #define ERR_OPENCL_CONTEXT_CREATE                    5103
#endif
#ifndef ERR_OPENCL_QUEUE_CREATE
    #define ERR_OPENCL_QUEUE_CREATE                      5104
#endif
#ifndef ERR_OPENCL_PROGRAM_CREATE
    #define ERR_OPENCL_PROGRAM_CREATE                    5105
#endif
#ifndef ERR_OPENCL_TOO_LONG_KERNEL_NAME
    #define ERR_OPENCL_TOO_LONG_KERNEL_NAME              5106
#endif
#ifndef ERR_OPENCL_KERNEL_CREATE
    #define ERR_OPENCL_KERNEL_CREATE                     5107
#endif
#ifndef ERR_OPENCL_SET_KERNEL_PARAMETER
    #define ERR_OPENCL_SET_KERNEL_PARAMETER              5108
#endif
#ifndef ERR_OPENCL_EXECUTE
    #define ERR_OPENCL_EXECUTE                           5109
#endif
#ifndef ERR_OPENCL_WRONG_BUFFER_SIZE
    #define ERR_OPENCL_WRONG_BUFFER_SIZE                 5110
#endif
#ifndef ERR_OPENCL_WRONG_BUFFER_OFFSET
    #define ERR_OPENCL_WRONG_BUFFER_OFFSET               5111
#endif
#ifndef ERR_OPENCL_BUFFER_CREATE
    #define ERR_OPENCL_BUFFER_CREATE                     5112
#endif
#ifndef ERR_OPENCL_TOO_MANY_OBJECTS
    #define ERR_OPENCL_TOO_MANY_OBJECTS                  5113
#endif
#ifndef ERR_OPENCL_SELECTDEVICE
    #define ERR_OPENCL_SELECTDEVICE                      5114
#endif


/////////////////////////////////////////////////////////////////////
//
// Operations with Databases
//

////////////////////////////////
//
// This is a temporary fix
//  https://www.mql5.com/en/forum/445076#comment_46332847
//
#undef ERR_DATABASE_INTERNAL
#define ERR_DATABASE_INTERNAL                        5120
///////////////////////////////

#ifndef ERR_DATABASE_INTERNAL
    #define ERR_DATABASE_INTERNAL                        5120
#endif
#ifndef ERR_DATABASE_INVALID_HANDLE
    #define ERR_DATABASE_INVALID_HANDLE                  5121
#endif
#ifndef ERR_DATABASE_TOO_MANY_OBJECTS
    #define ERR_DATABASE_TOO_MANY_OBJECTS                5122
#endif
#ifndef ERR_DATABASE_CONNECT
    #define ERR_DATABASE_CONNECT                         5123
#endif
#ifndef ERR_DATABASE_EXECUTE
    #define ERR_DATABASE_EXECUTE                         5124
#endif
#ifndef ERR_DATABASE_PREPARE
    #define ERR_DATABASE_PREPARE                         5125
#endif
#ifndef ERR_DATABASE_NO_MORE_DATA
    #define ERR_DATABASE_NO_MORE_DATA                    5126
#endif
#ifndef ERR_DATABASE_STEP
    #define ERR_DATABASE_STEP                            5127
#endif
#ifndef ERR_DATABASE_NOT_READY
    #define ERR_DATABASE_NOT_READY                       5128
#endif
#ifndef ERR_DATABASE_BIND_PARAMETERS
    #define ERR_DATABASE_BIND_PARAMETERS                 5129
#endif


/////////////////////////////////////////////////////////////////////
//
// Operations with WebRequest
//
#ifndef ERR_WEBREQUEST_INVALID_ADDRESS
    #define ERR_WEBREQUEST_INVALID_ADDRESS               5200
#endif
#ifndef ERR_WEBREQUEST_CONNECT_FAILED
    #define ERR_WEBREQUEST_CONNECT_FAILED                5201
#endif
#ifndef ERR_WEBREQUEST_TIMEOUT
    #define ERR_WEBREQUEST_TIMEOUT                       5202
#endif
#ifndef ERR_WEBREQUEST_REQUEST_FAILED
    #define ERR_WEBREQUEST_REQUEST_FAILED                5203
#endif


/////////////////////////////////////////////////////////////////////
//
// Operations with Network Sockets
//
#ifndef ERR_NETSOCKET_INVALIDHANDLE
    #define ERR_NETSOCKET_INVALIDHANDLE                  5270
#endif
#ifndef ERR_NETSOCKET_TOO_MANY_OPENED
    #define ERR_NETSOCKET_TOO_MANY_OPENED                5271
#endif
#ifndef ERR_NETSOCKET_CANNOT_CONNECT
    #define ERR_NETSOCKET_CANNOT_CONNECT                 5272
#endif
#ifndef ERR_NETSOCKET_IO_ERROR
    #define ERR_NETSOCKET_IO_ERROR                       5273
#endif
#ifndef ERR_NETSOCKET_HANDSHAKE_FAILED
    #define ERR_NETSOCKET_HANDSHAKE_FAILED               5274
#endif
#ifndef ERR_NETSOCKET_NO_CERTIFICATE
    #define ERR_NETSOCKET_NO_CERTIFICATE                 5275
#endif


/////////////////////////////////////////////////////////////////////
//
// Custom Symbols
//
#ifndef ERR_NOT_CUSTOM_SYMBOL
    #define ERR_NOT_CUSTOM_SYMBOL                        5300
#endif
#ifndef ERR_CUSTOM_SYMBOL_WRONG_NAME
    #define ERR_CUSTOM_SYMBOL_WRONG_NAME                 5301
#endif
#ifndef ERR_CUSTOM_SYMBOL_NAME_LONG
    #define ERR_CUSTOM_SYMBOL_NAME_LONG                  5302
#endif
#ifndef ERR_CUSTOM_SYMBOL_PATH_LONG
    #define ERR_CUSTOM_SYMBOL_PATH_LONG                  5303
#endif
#ifndef ERR_CUSTOM_SYMBOL_EXIST
    #define ERR_CUSTOM_SYMBOL_EXIST                      5304
#endif
#ifndef ERR_CUSTOM_SYMBOL_ERROR
    #define ERR_CUSTOM_SYMBOL_ERROR                      5305
#endif
#ifndef ERR_CUSTOM_SYMBOL_SELECTED
    #define ERR_CUSTOM_SYMBOL_SELECTED                   5306
#endif
#ifndef ERR_CUSTOM_SYMBOL_PROPERTY_WRONG
    #define ERR_CUSTOM_SYMBOL_PROPERTY_WRONG             5307
#endif
#ifndef ERR_CUSTOM_SYMBOL_PARAMETER_ERROR
    #define ERR_CUSTOM_SYMBOL_PARAMETER_ERROR            5308
#endif
#ifndef ERR_CUSTOM_SYMBOL_PARAMETER_LONG
    #define ERR_CUSTOM_SYMBOL_PARAMETER_LONG             5309
#endif
#ifndef ERR_CUSTOM_TICKS_WRONG_ORDER
    #define ERR_CUSTOM_TICKS_WRONG_ORDER                 5310
#endif


/////////////////////////////////////////////////////////////////////
//
// Economics calendar
//
#ifndef ERR_CALENDAR_MORE_DATA
    #define ERR_CALENDAR_MORE_DATA                       5400
#endif
#ifndef ERR_CALENDAR_TIMEOUT
    #define ERR_CALENDAR_TIMEOUT                         5401
#endif
#ifndef ERR_CALENDAR_NO_DATA
    #define ERR_CALENDAR_NO_DATA                         5402
#endif


/////////////////////////////////////////////////////////////////////
//
// Working with Databases
//
#ifndef ERR_DATABASE_ERROR
    #define ERR_DATABASE_ERROR                           5601
#endif
#ifndef ERR_DATABASE_LOGIC
    #define ERR_DATABASE_LOGIC                           5602
#endif
#ifndef ERR_DATABASE_PERM
    #define ERR_DATABASE_PERM                            5603
#endif
#ifndef ERR_DATABASE_ABORT
    #define ERR_DATABASE_ABORT                           5604
#endif
#ifndef ERR_DATABASE_BUSY
    #define ERR_DATABASE_BUSY                            5605
#endif
#ifndef ERR_DATABASE_LOCKED
    #define ERR_DATABASE_LOCKED                          5606
#endif
#ifndef ERR_DATABASE_NOMEM
    #define ERR_DATABASE_NOMEM                           5607
#endif
#ifndef ERR_DATABASE_READONLY
    #define ERR_DATABASE_READONLY                        5608
#endif
#ifndef ERR_DATABASE_INTERRUPT
    #define ERR_DATABASE_INTERRUPT                       5609
#endif
#ifndef ERR_DATABASE_IOERR
    #define ERR_DATABASE_IOERR                           5610
#endif
#ifndef ERR_DATABASE_CORRUPT
    #define ERR_DATABASE_CORRUPT                         5611
#endif
#ifndef ERR_DATABASE_NOTFOUND
    #define ERR_DATABASE_NOTFOUND                        5612
#endif
#ifndef ERR_DATABASE_FULL
    #define ERR_DATABASE_FULL                            5613
#endif
#ifndef ERR_DATABASE_CANTOPEN
    #define ERR_DATABASE_CANTOPEN                        5614
#endif
#ifndef ERR_DATABASE_PROTOCOL
    #define ERR_DATABASE_PROTOCOL                        5615
#endif
#ifndef ERR_DATABASE_EMPTY
    #define ERR_DATABASE_EMPTY                           5616
#endif
#ifndef ERR_DATABASE_SCHEMA
    #define ERR_DATABASE_SCHEMA                          5617
#endif
#ifndef ERR_DATABASE_TOOBIG
    #define ERR_DATABASE_TOOBIG                          5618
#endif
#ifndef ERR_DATABASE_CONSTRAINT
    #define ERR_DATABASE_CONSTRAINT                      5619
#endif
#ifndef ERR_DATABASE_MISMATCH
    #define ERR_DATABASE_MISMATCH                        5620
#endif
#ifndef ERR_DATABASE_MISUSE
    #define ERR_DATABASE_MISUSE                          5621
#endif
#ifndef ERR_DATABASE_NOLFS
    #define ERR_DATABASE_NOLFS                           5622
#endif
#ifndef ERR_DATABASE_AUTH
    #define ERR_DATABASE_AUTH                            5623
#endif
#ifndef ERR_DATABASE_FORMAT
    #define ERR_DATABASE_FORMAT                          5624
#endif
#ifndef ERR_DATABASE_RANGE
    #define ERR_DATABASE_RANGE                           5625
#endif
#ifndef ERR_DATABASE_NOTADB
    #define ERR_DATABASE_NOTADB                          5626
#endif


/////////////////////////////////////////////////////////////////////
//
// Return Codes of the Trade Server
//
#ifndef TRADE_RETCODE_REQUOTE
    #define TRADE_RETCODE_REQUOTE                        10004
#endif
#ifndef TRADE_RETCODE_REJECT
    #define TRADE_RETCODE_REJECT                         10006
#endif
#ifndef TRADE_RETCODE_CANCEL
    #define TRADE_RETCODE_CANCEL                         10007
#endif
#ifndef TRADE_RETCODE_PLACED
    #define TRADE_RETCODE_PLACED                         10008
#endif
#ifndef TRADE_RETCODE_DONE
    #define TRADE_RETCODE_DONE                           10009
#endif
#ifndef TRADE_RETCODE_DONE_PARTIAL
    #define TRADE_RETCODE_DONE_PARTIAL                   10010
#endif
#ifndef TRADE_RETCODE_ERROR
    #define TRADE_RETCODE_ERROR                          10011
#endif
#ifndef TRADE_RETCODE_TIMEOUT
    #define TRADE_RETCODE_TIMEOUT                        10012
#endif
#ifndef TRADE_RETCODE_INVALID
    #define TRADE_RETCODE_INVALID                        10013
#endif
#ifndef TRADE_RETCODE_INVALID_VOLUME
    #define TRADE_RETCODE_INVALID_VOLUME                 10014
#endif
#ifndef TRADE_RETCODE_INVALID_PRICE
    #define TRADE_RETCODE_INVALID_PRICE                  10015
#endif
#ifndef TRADE_RETCODE_INVALID_STOPS
    #define TRADE_RETCODE_INVALID_STOPS                  10016
#endif
#ifndef TRADE_RETCODE_TRADE_DISABLED
    #define TRADE_RETCODE_TRADE_DISABLED                 10017
#endif
#ifndef TRADE_RETCODE_MARKET_CLOSED
    #define TRADE_RETCODE_MARKET_CLOSED                  10018
#endif
#ifndef TRADE_RETCODE_NO_MONEY
    #define TRADE_RETCODE_NO_MONEY                       10019
#endif
#ifndef TRADE_RETCODE_PRICE_CHANGED
    #define TRADE_RETCODE_PRICE_CHANGED                  10020
#endif
#ifndef TRADE_RETCODE_PRICE_OFF
    #define TRADE_RETCODE_PRICE_OFF                      10021
#endif
#ifndef TRADE_RETCODE_INVALID_EXPIRATION
    #define TRADE_RETCODE_INVALID_EXPIRATION             10022
#endif
#ifndef TRADE_RETCODE_ORDER_CHANGED
    #define TRADE_RETCODE_ORDER_CHANGED                  10023
#endif
#ifndef TRADE_RETCODE_TOO_MANY_REQUESTS
    #define TRADE_RETCODE_TOO_MANY_REQUESTS              10024
#endif
#ifndef TRADE_RETCODE_NO_CHANGES
    #define TRADE_RETCODE_NO_CHANGES                     10025
#endif
#ifndef TRADE_RETCODE_SERVER_DISABLES_AT
    #define TRADE_RETCODE_SERVER_DISABLES_AT             10026
#endif
#ifndef TRADE_RETCODE_CLIENT_DISABLES_AT
    #define TRADE_RETCODE_CLIENT_DISABLES_AT             10027
#endif
#ifndef TRADE_RETCODE_LOCKED
    #define TRADE_RETCODE_LOCKED                         10028
#endif
#ifndef TRADE_RETCODE_FROZEN
    #define TRADE_RETCODE_FROZEN                         10029
#endif
#ifndef TRADE_RETCODE_INVALID_FILL
    #define TRADE_RETCODE_INVALID_FILL                   10030
#endif
#ifndef TRADE_RETCODE_CONNECTION
    #define TRADE_RETCODE_CONNECTION                     10031
#endif
#ifndef TRADE_RETCODE_ONLY_REAL
    #define TRADE_RETCODE_ONLY_REAL                      10032
#endif
#ifndef TRADE_RETCODE_LIMIT_ORDERS
    #define TRADE_RETCODE_LIMIT_ORDERS                   10033
#endif
#ifndef TRADE_RETCODE_LIMIT_VOLUME
    #define TRADE_RETCODE_LIMIT_VOLUME                   10034
#endif
#ifndef TRADE_RETCODE_INVALID_ORDER
    #define TRADE_RETCODE_INVALID_ORDER                  10035
#endif
#ifndef TRADE_RETCODE_POSITION_CLOSED
    #define TRADE_RETCODE_POSITION_CLOSED                10036
#endif
#ifndef TRADE_RETCODE_INVALID_CLOSE_VOLUME
    #define TRADE_RETCODE_INVALID_CLOSE_VOLUME           10038
#endif
#ifndef TRADE_RETCODE_CLOSE_ORDER_EXIST
    #define TRADE_RETCODE_CLOSE_ORDER_EXIST              10039
#endif
#ifndef TRADE_RETCODE_LIMIT_POSITIONS
    #define TRADE_RETCODE_LIMIT_POSITIONS                10040
#endif
#ifndef TRADE_RETCODE_REJECT_CANCEL
    #define TRADE_RETCODE_REJECT_CANCEL                  10041
#endif
#ifndef TRADE_RETCODE_LONG_ONLY
    #define TRADE_RETCODE_LONG_ONLY                      10042
#endif
#ifndef TRADE_RETCODE_SHORT_ONLY
    #define TRADE_RETCODE_SHORT_ONLY                     10043
#endif
#ifndef TRADE_RETCODE_CLOSE_ONLY
    #define TRADE_RETCODE_CLOSE_ONLY                     10044
#endif
#ifndef TRADE_RETCODE_FIFO_ONLY
    #define TRADE_RETCODE_FIFO_ONLY                      10045
#endif
#ifndef TRADE_RETCODE_HEDGE_PROHIBITED
    #define TRADE_RETCODE_HEDGE_PROHIBITED               10046
#endif




/**********************************************************************************/
#endif // LIB_ERRDEFINITIONS_MQH_INCLUDED